summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorBenjamin Dauvergne <bdauvergne@entrouvert.com>2014-10-02 21:48:19 (GMT)
committerBenjamin Dauvergne <bdauvergne@entrouvert.com>2014-10-02 22:32:09 (GMT)
commitab8f1c7c8a315767df0a3c5d6f40bb1aa81f2013 (patch)
tree29d3c9e15f0e78585e9887433efcac4611a9dd09
parent30f22a10272f8fe5b6d827df6d9645c280ad8e95 (diff)
downloadgstatsd-debian.zip
gstatsd-debian.tar.gz
gstatsd-debian.tar.bz2
Add init script and postinst to create daemon userdebian
-rw-r--r--debian/config2
-rw-r--r--debian/etc/default/gstatsd11
-rwxr-xr-xdebian/init.d141
-rw-r--r--debian/install1
-rw-r--r--debian/postinst27
5 files changed, 182 insertions, 0 deletions
diff --git a/debian/config b/debian/config
new file mode 100644
index 0000000..5f51f2e
--- /dev/null
+++ b/debian/config
@@ -0,0 +1,2 @@
+/etc/init.d/gstatsd
+/etc/default/gstatsd
diff --git a/debian/etc/default/gstatsd b/debian/etc/default/gstatsd
new file mode 100644
index 0000000..69a7736
--- /dev/null
+++ b/debian/etc/default/gstatsd
@@ -0,0 +1,11 @@
+# Flush buffers every 10 seconds
+FLUSH=10
+
+# Percent threshold
+PERCENT_THRESHOLD=90
+
+# Default Graphite receiver
+SINK=":2003"
+
+# Daemon arguments
+# DAEMON_ARGS=${DAEMON_ARGS:-"-f $FLUSH -s $SINK -p $PERCENT_THRESHOLD"}
diff --git a/debian/init.d b/debian/init.d
new file mode 100755
index 0000000..b37e2b0
--- /dev/null
+++ b/debian/init.d
@@ -0,0 +1,141 @@
+#!/bin/sh
+### BEGIN INIT INFO
+# Provides: gstatsd
+# Required-Start: $network $local_fs
+# Required-Stop:
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: StatsD daemon using gevent
+### END INIT INFO
+
+# Author: Benjamin Dauvergne <bdauvergne@entrouvert.com>
+
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC=GStatsD
+NAME=gstatsd
+DAEMON=/usr/bin/gstatsd
+RUN_DIR=/var/run/$NAME
+PIDFILE=$RUN_DIR/$NAME.pid
+LOG_DIR=/var/log/$NAME
+SCRIPTNAME=/etc/init.d/$NAME
+MANAGE_SCRIPT=/usr/lib/$NAME/manage.py
+FLUSH=10
+PERCENT_THRESHOLD=90
+
+USER=$NAME
+GROUP=$NAME
+
+# Exit if the package is not installed
+[ -x $DAEMON ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+# Verify that a sink has been defined
+[ -z "$SINK" ] && log_warning_msg "SINK is not defined in /etc/default/$NAME" && exit 0
+
+# Build daemon arguments
+DAEMON_ARGS=${DAEMON_ARGS:-"-f $FLUSH -s $SINK -p $PERCENT_THRESHOLD"}
+
+# Create /run directory
+if [ ! -d $RUN_DIR ]; then
+ install -d -m 755 -o $USER -g $GROUP $RUN_DIR
+fi
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --background --make-pidfile --chuid $USER:$GROUP --exec $DAEMON -- \
+ $DAEMON_ARGS \
+ || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+ # Wait for children to finish too if this is a daemon that forks
+ # and if the daemon is only ever run from this initscript.
+ # If the above conditions are not satisfied then add some other code
+ # that waits for the process to drop all resources that could be
+ # needed by services started subsequently. A last resort is to
+ # sleep for some time.
+ start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+ [ "$?" = 2 ] && return 2
+ # Many daemons don't delete their pidfiles when they exit.
+ rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+case "$1" in
+ start)
+ log_daemon_msg "Starting $DESC " "$NAME"
+ do_start
+ case "$?" in
+ 0|1) log_end_msg 0 ;;
+ 2) log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) log_end_msg 0 ;;
+ 2) log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
+
diff --git a/debian/install b/debian/install
new file mode 100644
index 0000000..784baaf
--- /dev/null
+++ b/debian/install
@@ -0,0 +1 @@
+debian/etc/default/gstatsd /etc/default
diff --git a/debian/postinst b/debian/postinst
new file mode 100644
index 0000000..72d983e
--- /dev/null
+++ b/debian/postinst
@@ -0,0 +1,27 @@
+#! /bin/sh
+
+set -e
+
+case "$1" in
+ configure)
+ if ! getent passwd gstatsd >/dev/null; then
+ adduser --disabled-password --quiet --system \
+ --no-create-home --home / \
+ --gecos "gStatsD software user" --group gstatsd
+ fi
+ ;;
+ reconfigure)
+ ;;
+
+ abort-upgrade|abort-remove|abort-deconfigure)
+ ;;
+ *)
+ echo "postinst called with unknown argument \`$1'" >&2
+ exit 1
+ ;;
+esac
+
+#DEBHELPER#
+
+exit 0
+